#!/bin/sh

# not pipe-p2, which will block. 

# make clean 
make tools/gfs3f geekos/hdbootsect
tools/gfs3f gfs3-battery.img geekos/hdbootsect 1500 
test -e gfs3-battery.img || exit -2

grep Failed output.log

make -j4 run OPTIMIZE="-O2" ARGS="-testInput 'b a b c\nforkpipe\ncPaging\ndiagnost\nexecr2 10\nexecr3 10\nfork-p1\nforkexec\nforkpop\nls\npipe-p1\npipe-p3\nps\nrec 200 q\noverstck\nprintgs\nsigpipe\nsemtest\nsync\nrodata\nmlc\nmultimlc\ndontstrv\nfreetest\nblkpipe\ngfs3tst prep\ngfs3tst all\nrec 1000 q\nworkload rr\nworkload mys\n\nforkpop\nmultimlc\nforkpop\nworkload rr\nworkload mys\ndontstrv\nexecr3 40\ndontstrv\nworkload rr\ndontstrv\nforkpop\nhalt\n' -hdb gfs3-battery.img"

make clean 
make tools/gfs3f geekos/hdbootsect
tools/gfs3f gfs3-battery.img geekos/hdbootsect 1500 

echo "*** RUNNING NO OPTIMIZATION ***"
make -j4 run OPTIMIZE="" ARGS="-testInput 'b a b c\nforkpipe\ncPaging\ndiagnost\nexecr2 10\nexecr3 10\nfork-p1\nforkexec\nforkpop\nls\npipe-p1\npipe-p3\nps\nrec 200 q\noverstck\nprintgs\nsigpipe\nsemtest\nsync\nrodata\nmlc\nmultimlc\ndontstrv\nfreetest\nblkpipe\ngfs3tst prep\ngfs3tst all\nrec 1000 q\nworkload rr\nworkload mys\n\nforkpop\nmultimlc\nforkpop\nworkload rr\nworkload mys\ndontstrv\nexecr3 40\ndontstrv\nworkload rr\ndontstrv\nforkpop\nhalt\n' -hdb gfs3-battery.img"

# cat output.log
grep Failed output.log && exit 1

# if we got this far, probably good.
exit 0
