/*
 * GeekOS file system
 * Copyright (c) 2008, David H. Hovemeyer <daveho@cs.umd.edu>, 
 * Neil Spring <nspring@cs.umd.edu>, Aaron Schulman <schulman@cs.umd.edu>
 * Leo Liu <leoliu@cs.umd.edu>
 *
 * All rights reserved.
 *
 * This code may not be resdistributed without the permission of the copyright holders.
 * Any student solutions using any of this code base constitute derviced work and may
 * not be redistributed in any form.  This includes (but is not limited to) posting on
 * public forums or web sites, providing copies to (past, present, or future) students
 * enrolled in similar operating systems courses the University of Maryland's CMSC412 course.
 */


#include <geekos/lfs.h>
#include <geekos/malloc.h>
#include <geekos/errno.h>
#include <geekos/vfs.h>
#include <geekos/string.h>
#include <geekos/projects.h>
#include <geekos/bufcache.h>
#include <geekos/string.h>


static int LFS_Write(struct File *f, void *buf, ulong_t numBytes) {
    TODO_P(PROJECT_LFS, "GeekOS filesystem write operation");
    return EUNSUPPORTED;
}


static int LFS_Disk_Properties(struct Mount_Point *mountPoint,
                               unsigned int *block_size,
                               unsigned int *blocks_in_disk) {
    TODO_P(PROJECT_LFS,
           "GeekOS filesystem infomation operation; set variables.");
    return EUNSUPPORTED;
}

static int LFS_FStat(struct File *file, struct VFS_File_Stat *stat) {
    TODO_P(PROJECT_LFS, "GeekOS filesystem stat operation");
    return EUNSUPPORTED;
}

static int LFS_Read(struct File *file, void *buf, ulong_t numBytes) {
    TODO_P(PROJECT_LFS, "GeekOS filesystem read operation");
    return EUNSUPPORTED;
}

static int LFS_Seek(struct File *file, ulong_t pos) {
    TODO_P(PROJECT_LFS, "GeekOS filesystem seek operation");
    return EUNSUPPORTED;
}

static int LFS_Close(struct File *file) {
    TODO_P(PROJECT_LFS, "GeekOS filesystem close operation");
    return EUNSUPPORTED;
}

static int LFS_Create_Directory(struct Mount_Point *mountPoint,
                                const char *path) {
    TODO_P(PROJECT_LFS, "GeekOS filesystem create directory operation");
    return EUNSUPPORTED;
}

static int LFS_Open_Directory(struct Mount_Point *mountPoint,
                              const char *path, struct File **pDir) {
    TODO_P(PROJECT_LFS, "GeekOS filesystem open directory operation");
    return EUNSUPPORTED;
}

static int LFS_Stat(struct Mount_Point *mountPoint, const char *path,
                    struct VFS_File_Stat *stat) {
    TODO_P(PROJECT_LFS, "GeekOS filesystem stat operation");
    return EUNSUPPORTED;
}

static int LFS_Sync(struct Mount_Point *mountPoint) {
    TODO_P(PROJECT_LFS, "GeekOS filesystem sync operation");
    return EUNSUPPORTED;
}

/*
 * Stat operation for an already open directory.
 */
static int LFS_FStat_Directory(struct File *dir,
                               struct VFS_File_Stat *stat) {
    TODO_P(PROJECT_LFS, "GeekOS filesystem FStat directory operation");
    return EUNSUPPORTED;
}

/*
 * Directory Close operation.
 */
static int LFS_Close_Directory(struct File *dir) {
    TODO_P(PROJECT_LFS, "GeekOS filesystem Close directory operation");
    return EUNSUPPORTED;
}

static int LFS_Read_Entry(struct File *dir, struct VFS_Dir_Entry *entry) {

    TODO_P(PROJECT_LFS, "GeekOS filesystem Read_Entry operation");
    return EUNSUPPORTED;
}
static int LFS_Delete(struct Mount_Point *mountPoint, const char *path,
                      bool recursive) {
    return EUNSUPPORTED;

}

struct File_Ops s_lfsFileOps = {
    &LFS_FStat,
    &LFS_Read,
    &LFS_Write,
    &LFS_Seek,
    &LFS_Close,
    0,                          /* Read_Entry */
};

/*static*/ struct File_Ops s_lfsDirOps = {
    &LFS_FStat_Directory,
    0,                          /* Read */
    0,                          /* Write */
    0,                          /* Seek */
    &LFS_Close_Directory,
    &LFS_Read_Entry,
};



static int LFS_Open(struct Mount_Point *mountPoint, const char *path,
                    int mode, struct File **pFile) {

    TODO_P(PROJECT_LFS, "GeekOS filesystem open operation");
    return EUNSUPPORTED;
}


struct Mount_Point_Ops s_lfsMountPointOps = {
    &LFS_Open,
    &LFS_Create_Directory,
    &LFS_Open_Directory,
    &LFS_Stat,
    &LFS_Sync,
    &LFS_Delete,
    0,                          /* Rename  */
    0,                          /* Link  */
    0,                          /* SymLink  */
    0,                          /* setuid  */
    0,                          /* acl  */
    &LFS_Disk_Properties,
};

static int LFS_Mount(struct Mount_Point *mountPoint) {

    TODO_P(PROJECT_LFS, "GeekOS filesystem mount operation");
    return EUNSUPPORTED;
}

static int LFS_Format(struct Block_Device *device) {
    return EUNSUPPORTED;
}

static struct Filesystem_Ops s_lfsFilesystemOps = {
    &LFS_Format,
    &LFS_Mount,
};

void Init_LFS(void) {
    Register_Filesystem("lfs", &s_lfsFilesystemOps);
}
